<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!-- This collection of hypertext pages is Copyright 1995-7 by Steve Summit. -->
<!-- This material may be freely redistributed and used -->
<!-- but may not be republished or sold without permission. -->
<html>
<head>
<link rev="owner" href="mailto:scs@eskimo.com">
<link rev="made" href="mailto:scs@eskimo.com">
<title>Assignment #5</title>
</head>
<body>
<H1>Assignment #5</H1>





<B>Introductory C Programming
<br>
<br>
UW Experimental College
</B><br>
<br>
<B>Assignment #5
</B><p><B>Handouts:
</B></p><p><a href="PS5.html">Assignment #5</a>
<br><a href="PS4a.html">Answers to Assignment #4</a>
<br><a href="http://www.eskimo.com/~scs/cclass/notes/sx9.html">Class Notes, Chapter 9</a>
<br><a href="http://www.eskimo.com/~scs/cclass/notes/sx10.html">Class Notes, Chapter 10</a>
<p><B>Reading Assignment:
</B></p><p><a href="http://www.eskimo.com/~scs/cclass/notes/sx9.html">Class Notes, Chapter 9</a>
<p><B>Review Questions:
</B></p><OL><li>What's wrong with this <TT>#define</TT> line?
<pre>
	#define N 10;
</pre>
<li>Suppose you defined the macro
<pre>
	#define SIX 2*3
</pre>
Then, suppose you used it in another expression:
<pre>
	int x = 12 / SIX;
</pre>
What value would <TT>x</TT> be set to?
<li>If the header file <TT>x.h</TT> contains an external prototype declaration
for a function <TT>q()</TT>,
where should <TT>x.h</TT> be included?
<li>(harder)
How many differences can you think of between <TT>i</TT> and
<TT>J</TT> as defined by
these two lines?
<pre>
	int i = 10;
	#define J 10
</pre>
(Hint: think about trying to write <TT>J = 5</TT>, or <TT>int a[i]</TT>.)
</OL><br>
<br>
<p><B>Exercises:
</B></p><OL><li>Pick one of the programs we've worked with so far
that uses the <TT>getline</TT> function,
such as the <TT>getline</TT> test program

(assignment 4, exercise 2)
or the ``word zipping'' program

(assignment 4, tutorial 3)
or the checkbook balancing program

(assignment 4, exercise 6).

Arrange the program in two source files,
one containing <TT>main()</TT>,
and one containing <TT>getline()</TT>.
If possible, set your compiler to warn you
when functions are called or defined without a prototype in scope.
Create a header file <TT>getline.h</TT>
containing the external function prototype for <TT>getline()</TT>,
and <TT>#include</TT> it as you see fit.
Also use a preprocessor macro such as <TT>MAXLINE</TT>
for the maximum line length
(i.e. in declarations of <TT>line</TT> arrays,
and calls to <TT>getline</TT>).
<li>Write a program to read its input and write it out, double-spaced
(that is, with an extra blank line between each line).
Process the input a character at a time;
do <em>not</em> read
entire lines at a time
using <TT>getline</TT>.
<li>Write the function
<pre>
	int countchars(char string[], int ch);
</pre>
which returns the number of times the character <TT>ch</TT> appears in the
<TT>string</TT>.
For example, the call
<pre>
	countchars("Hello, world!", 'o')
</pre>
would return 2.
<li>Write a short program to read two lines of text, and concatenate
them using <TT>strcat</TT>.  Since <TT>strcat</TT> concatenates in-place, you'll
have to make sure you have enough memory to hold the concatenated
copy.  For now, use a <TT>char</TT> array which is twice as big as either
of the arrays you use for reading the two lines.  Use <TT>strcpy</TT> to
copy the first string to the destination array, and <TT>strcat</TT> to
append the second one.
<li>Write the function
<pre>
	replace(char string[], char from[], char to[])
</pre>
which finds the string <TT>from</TT> in the string <TT>string</TT>

and replaces
it with the string <TT>to</TT>.
You may assume that <TT>from</TT>
and <TT>to</TT> are the same length.  For example, the code
<pre>
	char string[] = "recieve";
	replace(string, "ie", "ei");
</pre>
should change <TT>string</TT> to <TT>"receive"</TT>.
<br>
<br>
(Extra credit:
Think about what <TT>replace()</TT> should do
if the <TT>from</TT> string appears multiple times
in the input string.)
</OL><hr>
<hr>
<p>
This page by <a href="http://www.eskimo.com/~scs/">Steve Summit</a>
// <a href="copyright.html">Copyright</a> 1995-9
// <a href="mailto:scs@eskimo.com">mail feedback</a>
</p>
</body>
</html>
